<template>
  <v-app class="statementOfPaid">
    <div class="statementOfPaid__title">
      <h1>Ведомость оказанных услуг</h1>
    </div>

    <div class="statementOfPaid__subtitle">
      <h2>Нажмите для создания отчёта</h2>
    </div>

    <v-dialog v-model="dialog" max-width="500px">
      <template v-slot:activator="{ on, attrs }">
        <v-btn class="statementOfPaid__btn" v-bind="attrs" v-on="on" style="margin-right: auto">Создать</v-btn>
      </template>
      <v-card >
        <v-card-title>
          <span class="text-h5">{{ "Получить отчёт" }}</span>
        </v-card-title>

        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12" sm="6" md="12">
                <v-text-field v-model="dialogItem.dateFrom" label="С"></v-text-field>
              </v-col>
              <v-col cols="12" sm="6" md="12">
                <v-text-field v-model="dialogItem.dateTo" label="До"></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>


        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="#AFFFCF" @click="close">Закрыть</v-btn>
          <v-btn color="#AFFFCF" @click="requestReport">Получить отчет</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <!--Поиск пациента-->
    <v-text-field class="statementOfPaid__search" v-model="search" append-icon="mdi-magnify" label="Поиск.." single-line
                  hide-details></v-text-field>

    <v-container class="statementOfPaid__tables">
      <v-data-table
          :headers="headersService"
          :items="paidServices"
          :search="search"
          class="statementOfPaid__table_1"
          sort-by="id"
      >
      </v-data-table>
      <v-data-table
          :headers="headersDrug"
          :items="paidDrugs"
          :search="search"
          class="statementOfPaid__table_2"
          sort-by="id"
      >
      </v-data-table>
    </v-container>

  </v-app>
</template>

<script>
import axios from "axios";

export default {
  name: "StatementOfPaidServices",
  data() {
    return {
      dialog: false,
      paidServices: [],
      paidDrugs: [],
      statusMedications: [],
      statusReceipts: [],
      search: '',
      pdfsrc: '',

      dialogItem: {
        dateFrom: 'YYYY-MM-DD',
        dateTo: 'YYYY-MM-DD'
      },

      headersService: [
        {
          text: 'Фамилия',
          value: 'dailyStatus.medicalCard.patient.surname',
          sortable: false
        },
        {
          text: 'Имя',
          value: 'dailyStatus.medicalCard.patient.name',
          sortable: false
        },
        {
          text: 'Отчество',
          value: 'dailyStatus.medicalCard.patient.fatherName',
          sortable: false
        },
        {
          text: 'День',
          value: 'dailyStatus.date',
          sortable: false
        },
        {
          text: 'Услуга',
          value: 'medicationService.service.name',
          sortable: false
        },
        {
          text: 'Количество',
          value: 'medicationService.count',
        },
      ],

      headersDrug: [
        {
          text: 'Фамилия',
          value: 'dailyStatus.medicalCard.patient.surname',
          sortable: false
        },
        {
          text: 'Имя',
          value: 'dailyStatus.medicalCard.patient.name',
          sortable: false
        },
        {
          text: 'Отчество',
          value: 'dailyStatus.medicalCard.patient.fatherName',
          sortable: false
        },
        {
          text: 'День',
          value: 'dailyStatus.date',
          sortable: false
        },
        {
          text: 'Лекарство',
          value: 'receipt.drug.name',
          sortable: false
        },
        {
          text: 'Количество',
          value: 'receipt.count',
        },
      ]
    }
  },

  mounted() {
    this.fetchDailyStatus()
  },

  methods: {
    async fetchDailyStatus() {
      axios
          .get(this.$root.globalVar + '/daily_status_medication_service')
          .then(response => {
            this.paidServices = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })

      axios
          .get(this.$root.globalVar + '/daily_status_receipt')
          .then(response => {
            this.paidDrugs = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    async fetchReport(item) {
      axios
          .post(this.$root.globalVar + '/reports/monthly_statement_paid_services/', {
            dateTo: item.dateTo,
            dateFrom: item.dateFrom
          }, {
            responseType: 'blob'
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
          .then(response => {
            console.log("Success", response);
            const blob = new Blob([response.data], {type: 'application/pdf'});
            console.log(blob)
            const objectUrl = URL.createObjectURL(blob);
            this.pdfsrc = objectUrl;
            console.log(objectUrl);
            window.open(objectUrl)
            this.checker = true;
          })

    },

    close() {
      this.dialog = false
    },

    requestReport() {
      this.fetchReport(this.dialogItem)
      this.dialog = false
    }


  }
}
</script>

<style lang="scss" scoped>
.statementOfPaid {
  &__title {
    text-align: center;
    margin: 60px 0 30px 0;
  }

  &__subtitle {
    margin: 0 0 20px 50px
  }

  &__btn {
    margin: 0 0 30px 50px;
  }

  &__table_1, &__table_2 {
    width: 40%;
    margin: 0 auto;
  }

  &__table_1 {
    margin-right: 10px;
  }

  &__tables {
    display: flex;
  }
}

.v-text-field {
  flex: 0.3 0 !important;
  width: 50%;
  margin: 0 auto;
}
</style>